#!/usr/bin/python

# Lost Cities
# Copyright 2003, David "Novalis" Turner <novalis@fsf.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

class FnQueue:
    def timerEvent (self, e):
        try:
            if self.paused:
                return
        except AttributeError:
            pass
        
        if len (self.pendingEvents):
            e = self.pendingEvents.pop ()
            (function, callback, args) = e
            v = function (*args)
            if callback:
                callback (v)

    def storeEvent (self, function, callback, *args):
        self.pendingEvents.insert (0, (function, callback, args))

    def pause (self):
        self.paused = 1

    def unpause (self):
        self.paused = 0
