#!/usr/bin/python

# Lost Cities
# Copyright 2003, David "Novalis" Turner <novalis@fsf.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from qt import *

from Lobby import Lobby
from LostCitiesImpl import LostCitiesImpl
from FnQueue import FnQueue

class LobbyImpl (Lobby, FnQueue):
    def __init__ (self, conn, login):
        Lobby.__init__ (self)
        self.conn = conn
        self.login = login
        self.theyChallengedPixmap = QPixmap ("theychallenged.png")
        self.youChallengedPixmap = QPixmap ("youchallenged.png")
        self.opponents = {}
            
        self.pendingEvents = []
        self.startTimer (1)

    def talk (self):
        text = self.chatInput.text ()
        self.chatInput.setText ("")
        self.conn.sendl ("chat", text)

    def gotChat (self, user, text):
        self.scrollback.append ('[' + user + ']: ' + text)

    def gotChallenge (self, opponent):
        if self.opponents.has_key (opponent):
            self.opponents [opponent] = 1
            l = self.users.findItem (opponent, 0)
        else:
            #we have never even heard of this opponent
            l = QListViewItem (self.users, opponent)
        l.setPixmap (1, self.theyChallengedPixmap)

    def challenge (self, item):
        #fixme: check first
        opponent = item.text (0)
        item.setPixmap (1, self.youChallengedPixmap)
        self.conn.sendl ("challenge", opponent)

    def user (self, users):
        for user in users:
            if not self.opponents.has_key (user):
                self.opponents [user] = 1
                l = QListViewItem (self.users, user)

    def initGame (self, opponent):
        self.hide ()
        l = LostCitiesImpl (self.conn, opponent)
        l.show ()
        return l

    def closeEvent (self, e):
        print "closed lobby"
        self.login.show ()
        self.login.close ()
        Lobby.closeEvent (self, e)
        
